/*! @file    ghcmio_api.h
    @author  loongworks@163.com
    @version V1.21.0407.2
    @date    7-APR-2021
    @brief   Export ghcmio library APIs.
*/

#ifndef _GHC_MIO_API_H_
#define _GHC_MIO_API_H_

/* Includes ------------------------------------------------------------------*/
#include "stdint.h"

/*! @def GHC_MIO_API
	@brief WindowsµĺԼ.
*/
#ifdef _WIN32
#ifdef GHC_MIO_API_EXPORTS
#define GHC_MIO_API __declspec(dllexport) __stdcall
#else
#define GHC_MIO_API __declspec(dllimport) __stdcall
#endif
#else
#define GHC_MIO_API
#endif

#ifdef __cplusplus
extern "C" {
#endif


	/*! @def IDCR_READ_MODE_COMPATIBLE
		@brief ֤USBüģʽ֧ٶȽUnixϵͳ.
	*/
#define IDCR_READ_MODE_COMPATIBLE 	0x0800u

	/*! @def IDCR_READ_MODE_EXT
		@brief ֤ȡϢ.
	*/
#define IDCR_READ_MODE_EXT 			0x0020u

	/*! @def IDCR_READ_MODE_REREAD
		@brief ֤ǿ¶ȡ.
	*/
#define IDCR_READ_MODE_REREAD		0x0010u

	/*! @def IDCR_READ_MODE_COMPOSITE
		@brief ֤ϳƬ.
	*/
#define IDCR_READ_MODE_COMPOSITE 	0x0008u

	/*! @def IDCR_READ_MODE_PHOTO
		@brief ֤ȡͷ.
	*/
#define IDCR_READ_MODE_PHOTO		0x0004u

	/*! @def IDCR_READ_MODE_TEXT
		@brief ֤ȡı.
	*/
#define IDCR_READ_MODE_TEXT			0x0002u

	/*! @def IDCR_READ_MODE_FINGER
		@brief ֤ȡָϢ.
	*/
#define IDCR_READ_MODE_FINGER		0x0001u

	/**
	* @brief ȡ̬汾ϢӲ
	**/
	void GHC_MIO_API mio_lib_version(char *version_info);

	/**
	 * @brief ȡ̼汾
	 */
	int32_t GHC_MIO_API mio_firm_version(size_t handle, uint8_t* pbsVerData,
	                                     int32_t* piVerLen);


	/**
	 * @brief 
	 */
	int32_t GHC_MIO_API mio_beep(size_t handle,
	                             uint8_t duration, uint8_t interval, uint8_t beeptimes);


	/**
	* @brief öϵĴںͿõUSB豸
	**/
	int32_t GHC_MIO_API mio_enumerate(char* devs_list);

	int32_t GHC_MIO_API mio_enum_devices(int32_t dev_type, char** p_out_info_buf);

	void GHC_MIO_API mio_free_list(const char* p_info_buf);


	/**
	* @brief һ豸
	**/
	size_t GHC_MIO_API mio_open(const char* psport, char* psexport, int32_t baud);

	/**
	 * @brief رһ豸
	 **/
	int32_t GHC_MIO_API mio_close(size_t handle, int32_t iPortTypeRfu);

    /**
    * @brief ò
    **/
    int32_t GHC_MIO_API mio_set_baud(size_t handle, uint32_t baud, uint8_t save_mode);

	/**************************************************************************/

	/**
	 * @brief ſ
	 */
	int32_t GHC_MIO_API mio_msr_qm_start(size_t handle);


	/**
	 * @brief ȡſ״̬
	*/
	int32_t GHC_MIO_API mio_msr_qm_status(size_t handle);


	/**
	 * @brief ȡĴ
	*/
	int32_t GHC_MIO_API mio_msr_qm_get(size_t handle,
	                                   char *track1, char *track2, char *track3,
	                                   int32_t *track1len, int32_t *track2len, int32_t *track3len);


	/**
	 * @brief 
	*/
	int32_t GHC_MIO_API mio_msr_qm_stop(size_t handle);

	/**
	 * @brief ȡſraw״̬
	*/
	int32_t GHC_MIO_API mio_msr_qm_status_raw(size_t handle);

	/**
	 * @brief ȡĴ
	*/
	int32_t GHC_MIO_API mio_msr_qm_get_raw(size_t handle, int32_t index,
	                                   char *track, int32_t *tracklen);

	/**
	 * @brief raw
	*/
	int32_t GHC_MIO_API mio_msr_qm_stop_raw(size_t handle);

	/**
	 * @brief rawתΪַ
	*/
	int32_t GHC_MIO_API mio_msr_raw2str(char *praw, int32_t raw_len, char * pstr);

	/**
	 * @brief rawתΪ
	*/
	int32_t GHC_MIO_API mio_msr_get_crypto_card_sn(char *praw, int32_t raw_len, char * pstr);

	/**
	 * @brief ȡд
	*/
	int32_t GHC_MIO_API mio_msr_cancel(size_t handle);

	/**
	 * @brief Ϣ
	*/
	int32_t  GHC_MIO_API mio_msr_erase(size_t handle, int32_t trackselect,
	                                   int32_t timeout_ms);

	/**
	 * @brief ȡϢʽ
	*/
	int32_t GHC_MIO_API  mio_msr_read(size_t handle,
	                                  int32_t trackselect, char *track1, char *track2, char *track3,
	                                  int32_t timeout);

	/**
	 * @brief дϢ
	*/
	int32_t  GHC_MIO_API mio_msr_write(size_t handle,
	                                   int32_t trackselect, int32_t delimiter,
	                                   const char *track1, const char *track2, const char *track3, int32_t timeout_ms);

	/**************************************************************************/

	/**
	 * @brief 豸ϵ
	 */
	int32_t GHC_MIO_API mio_icc_poweron(size_t handle,
	                                    uint8_t card_type, uint16_t timeout, char* atr, int32_t * length);


	/**
	 * @brief 豸µ
	*/
	int32_t GHC_MIO_API mio_icc_poweroff(size_t handle,
	                                     uint8_t card_type, uint16_t timeout);


	/**
	 * @brief ȡӴ״̬
	*/
	int32_t GHC_MIO_API mio_icc_status(size_t handle, uint8_t card_type);


	/**
	 * @brief APDU
	*/
	int32_t GHC_MIO_API mio_icc_apdu(size_t handle,
	                                 uint8_t card_type, const char *psapdu, int32_t apdu_length,
	                                 char *psrpdu, int32_t *rpdu_len);

	//---------------------------------------------------------------------------------------

	/**
	 * @brief IC ȡƬϢ
	*/
	int32_t GHC_MIO_API mio_pboc_get_card_info(
	        size_t handle, uint8_t bCardSlot, uint16_t wTimeout, const char* aid,
	        const char* psTagList, uint8_t* pbsCardType,
	        uint8_t* psUserInfo, uint16_t* wInfoLen,
	        uint8_t bIsNeedPwrOn);

	// IC ARQC
	int32_t GHC_MIO_API mio_pboc_get_arqc(
	        size_t handle, uint8_t bCardSlot, uint16_t wTimeout,
	        const char* aid, uint16_t wAidLen,
	        const uint8_t* psTxDat, uint16_t wTxDatLen, uint8_t* psArqc,
	        uint16_t* pwArqcLen, uint8_t bIsNeedPwrOn);

	// IC ARPC ִнű
	int32_t GHC_MIO_API mio_pboc_arpc_exec_script(size_t handle, uint8_t bCardSlot,
	                uint16_t wTimeout, const uint8_t* psTxDat, uint16_t wTxDatLen,
	                const uint8_t* psArpc, uint16_t wArpcLen,
	                uint8_t* pbsOutBuf, uint16_t* pwOutLen);

	// IC ȡϸ
	int32_t GHC_MIO_API mio_pboc_get_trans_detail(
	        size_t handle, uint8_t bCardSlot, uint16_t wTimeout, uint8_t num,
	        const char* aid,
	        uint8_t* psDetail, uint16_t* pwDetailLen, uint8_t bIsNeedPwrOn);

	// IC ȡƬȫϢ+Arqc
	int32_t GHC_MIO_API mio_pboc_get_card_info_all(size_t handle, uint8_t bCardSlot,
	                uint16_t wTimeout, const char* psTagList, uint8_t* pbsCardType,
	                uint8_t* pbsOutBuf, uint16_t* pwOutBufLen, uint8_t bIsNeedPwrOn);

	// IC жϿƬӦǷ
	int32_t mio_pboc_is_app_locked(
	        size_t handle, uint8_t bCardSlot, uint16_t wTimeout, const char* aid,
	        uint8_t bIsNeedPwrOn);


	/***************************************************************************
							֤ӿ
	***************************************************************************/

	/**
	* @brief ȡ֤Ϣ
	**/
	int32_t GHC_MIO_API mio_idcr_read_bin(size_t handle, uint32_t read_mode, uint32_t timeout,
	                                      uint8_t *pabtext, uint32_t *puitextlen,
	                                      uint8_t *pabwlt, uint32_t *puiwltlen,
	                                      uint8_t *pabfp, uint32_t *puifplen,
	                                      uint8_t *pabxtra, uint32_t *puixtralen);


	/**
	* @brief ֤Ϣ
	**/
	int32_t GHC_MIO_API mio_idcr_read(size_t handle, uint32_t read_mode, uint32_t timeout);


	/**
	* @brief ȡ֤Ϣ
	**/
	int32_t GHC_MIO_API mio_idcr_getinfo(size_t handle, uint32_t read_mode, uint32_t timeout
	                                     , int32_t pictype, char *pstxt, char *psfp, const char *psphotopath,
	                                     const char *psfrontpath, const char *psbackpath);


     /**
      * @brief ö֤ϢʱķָĬǡ|ָΪⵥֽASCIIַ
      * @param [in] separation ָ
      *
      * @return
      *        none
     **/
     void GHC_MIO_API mio_idcr_set_separation(char separation);


	/**
	* @brief ȡ֤δԭʼ
	*/
	int32_t GHC_MIO_API mio_idcr_getraw(size_t handle, uint32_t raw_type, char *psbuf, int32_t *pidatlen);
	
	/**
	* @brief ȡSAMģID
	**/
	int32_t GHC_MIO_API mio_idcr_read_samid(size_t handle, uint32_t timeout, char *pssamid);

	/** 
	* @brief շAAָ
	* @param [in] handle, 豸
	* @param [in] timeout, ȴʱ룻
	* @param [in] bCmd, ָ֣
	* @param [in] bArg, ָ
	* @param [out] pdwRspCode, Ӧ룻
	* @param [out] psRspData, Ӧݣ
	* @param [in] iRspBufSize, ȣ
	* @param [out] piRspDataLen, Ӧݳȣ
	*
	* @return
	*		0  - ɹ
	*		<0 - ʧܣ
	**/
	int32_t GHC_MIO_API mio_idcr_transive(size_t handle, uint32_t timeout,
		uint8_t bCmd, uint8_t bArg,
		uint32_t *pdwRspCode, uint8_t *psRspData, int32_t iRspBufSize,
		int32_t *piRspDataLen);

	/**
	* @brief ȡ֤ID
	**/
	int32_t GHC_MIO_API mio_idcr_read_uid(size_t handle, uint32_t timeout, char *psuid);

	/**
	* @brief ֤DN
	**/
	int32_t GHC_MIO_API mio_idcr_read_dn(size_t handle, uint32_t timeout, char* psdn);

	/**
	* @brief ȡ125KHz EMID
	**/
	int32_t GHC_MIO_API mio_idcr_read_emid(size_t handle, uint32_t timeout, char* psemid);

	/**
	* @brief MifareѰϵ
	**/
	int32_t GHC_MIO_API mio_mifare_request(size_t handle, uint32_t timeout,
	                                       char *cardtype, char *psuid);

	/**
	* @brief Mifare֤˶룩
	**/
	int32_t GHC_MIO_API mio_mifare_authentication(size_t handle,
	                unsigned char sector, unsigned char key_type, const char* key);

	/**
	* @brief Mifare
	**/
	int32_t GHC_MIO_API mio_mifare_read_block(size_t handle,
	                unsigned char block, char * pblockdat);

	/**
	* @brief Mifareд
	**/
	int32_t GHC_MIO_API mio_mifare_write_block(size_t handle,
	                unsigned char block, const char * pblockdat);

	/**
	* @brief MifareĳһʼΪǮ
	**/
	int32_t GHC_MIO_API mio_mifare_init_value(size_t handle,
	                unsigned char block, int32_t value);


	/**
	* @brief MifareǮֵ
	**/
	int32_t GHC_MIO_API mio_mifare_read_value(size_t handle,
	                unsigned char block, int32_t *value);

	/**
	* @brief MifareǮֵ
	**/
	int32_t GHC_MIO_API mio_mifare_increase_value(size_t handle,
	                unsigned char block, int32_t value);

	/**
	* @brief MifareǮۿ
	**/
	int32_t GHC_MIO_API mio_mifare_decrease_value(size_t handle,
	                unsigned char block, int32_t value);

	/**
	* @brief MifareݻشM1ĳݴ洢ڵĻ
	**/
	int32_t GHC_MIO_API mio_mifare_restore(size_t handle, unsigned char block);

	/**
	* @brief MifareݴͣM1ڻдĳ飩
	**/
	int32_t GHC_MIO_API mio_mifare_transfer(size_t handle, unsigned char block);

	/**
	* @brief Mifare޸룬ע޸ǰҪ֤ſ
	**/
	int32_t GHC_MIO_API mio_mifare_change_key(size_t handle,
	                unsigned char sector, unsigned char key_type, const char* key);

	
	int32_t GHC_MIO_API mio_etc_read_number(size_t handle, uint8_t card_slot, uint16_t timeout, char* pscard_number);
	
#ifdef __cplusplus
}
#endif

#endif
